include	InputBox.inc

IDC_EDIT	equ 4001
IDB_OK		equ 4002
IDB_EXIT	equ 4003
IDC_STATIC	equ 4004

.data?

IBparams	dd ?
IBhEdit		dd ?
IBStrLen	dd ?

.code

IBDlgProc PROC USES esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
        .IF uMsg==WM_INITDIALOG

			mov		esi,lParam
			mov		IBparams,esi
			invoke	GetDlgItem,hWnd,IDC_STATIC			
			invoke	SendMessage,eax,WM_SETTEXT,0,DWORD PTR [esi-8]
			invoke	SendMessage,hWnd,WM_SETTEXT,0,DWORD PTR [esi-4]
			invoke	GetDlgItem,hWnd,IDC_EDIT
			mov		IBhEdit,eax
			mov		IBStrLen,0

		.ELSEIF uMsg==WM_CLOSE

			invoke	EndDialog,hWnd,IBStrLen										; IBStrLen -> length of the input text

		.ELSEIF uMsg==WM_COMMAND
		
			mov	eax,wParam
			mov	edx,eax
			shr	edx,16

				.IF dx==BN_CLICKED
                                
					.IF ax==IDB_EXIT
					
		                invoke	SendMessage,hWnd,WM_CLOSE,0,0

					.ELSEIF ax==IDB_OK || ax==IDOK								; check also if RETURN \ ENTER is pressed

						mov		esi,IBhEdit
						invoke	SendMessage,esi,WM_GETTEXTLENGTH,0,0
						mov		IBStrLen,eax
						test	eax,eax											; check the length of the input text
						jz		@f												; if no text is entered then quit application
						inc		eax
						mov		edx,IBparams									
						invoke	SendMessage,esi,WM_GETTEXT,eax,\
								DWORD PTR [edx]									; DWORD PTR [edx] -> pointer to the buffer receiving
					@@:															; keyboard input
		                invoke	SendMessage,hWnd,WM_CLOSE,0,0

					.ENDIF

				.ENDIF
		.ELSE

			xor	eax,eax
			ret

		.ENDIF

		mov eax,TRUE
		ret

IBDlgProc ENDP

END
